Python 2.7.5 (v2.7.5:ab05e7dd2788, May 13 2013, 13:18:45) 
[GCC 4.2.1 (Apple Inc. build 5666) (dot 3)] on darwin
Type "copyright", "credits" or "license()" for more information.
>>> ================================ RESTART ================================
>>> 
# Open the shelve file containing the model
>>> s=shelve.open('NewSBMLs')
# Load the model
>>> model=s['AB1']
# Find the biomass reaction by index
>>> model.findBiomassReaction()
760
# Determine its name in the model
>>> model.reactions[760].name
'R761'
# Print out its equation
>>> model.printReactionFormula(760)
'3/5 PROTEIN[cell] + 3/100 DNA[cell] + 19/100 RNA[cell] + 1/25 PHOSPHOLIPID[cell] + 1/50 LIPID[cell] + 1/200 LPS[cell] + 27/1000 PEPTIDO[cell] + 19/500 EXOPOLYS[cell] + 3/100 CAV[cell] + 46 ATP[cell] -> 1 BIOMASS[cell] + 46 ADP[cell] + 46 PI[cell]'
# Print out the pairs (metabolite, coefficient) contained in this reaction
>>> model.reactions[760].pairs
[[372, Fraction(-3, 5)], [164, Fraction(-3, 100)], [874, Fraction(-19, 100)], [707, Fraction(-1, 25)], [918, Fraction(-1, 50)], [466, Fraction(-1, 200)], [398, Fraction(-27, 1000)], [240, Fraction(-19, 500)],
 [63, Fraction(-3, 100)], [363, Fraction(-46, 1)], [447, Fraction(1, 1)], [821, Fraction(46, 1)], [87, Fraction(46, 1)]]
# Check the name of a specific metabolite
>>> model.metabolites[447].species.name
'BIOMASS'
# Check whether it is constrained
>>> model.metabolites[447].external
False
# Note that because it is a metabolite contained in a unique reaction, it will be a dead end; to unblock it (and the biomass reaction) we will add a biomass export reaction.
# Extract the full matrix of the model (containing both internal and external metabolites)
>>> Mat=model.fullMatrix
# Compute its dimensions
>>> m,n=getSize(Mat)
# Print number of rows (metabolites)
>>> m
997
# and number of columns (reactions)
>>> n
891
# Find all reactions involving the biomass metabolite
>>> [y for y in range(n) if Mat[447][y]]
[760]
# Add an export reaction for the biomass
>>> model.addReaction('Biomass export', [[447,-1]])
# Extract the augmented matrix
>>> MatAdj=model.fullMatrix
# Compute its dimensions again
>>> m1,n1=getSize(MatAdj)
# The number of rows (metabolites) is the same
>>> m1
997
# but there is an extra column, as expected
>>> n1
# Perform a complete structural analysis (make sure that you have QSopt_ex installed and located in the correct directory before you do this!)
892
>>> model.reduceNetwork()
#################################
# Removing output to save space #
#################################
# End of removed output         #
#################################
# Check the status of the biomass reaction
>>> model.reactions[760].reductionStatus
5
# This means it's in a reaction subset with other reactions; let's see which ones!
>>> [i for i,x in enumerate(model.reactionSubsets) if 760 in [y[0] for y in x.pairs]]
[0]
# It's part of the very first reaction subset - let's see what it's composed of (the first element is the reaction, the second is the multiplier)
>>> model.reactionSubsets[0].pairs
[[0, Fraction(1, 1)], [43, Fraction(-10070, 84551)], [44, Fraction(10070, 84551)], [45, Fraction(10070, 84551)], [48, Fraction(3280, 84551)], [54, Fraction(71068100, 97318201)], [55, Fraction(71068100, 97318201)],
 [56, Fraction(71068100, 97318201)], [57, Fraction(71068100, 97318201)], [61, Fraction(33750000, 97318201)], [62, Fraction(33750000, 97318201)], [65, Fraction(1275, 84551)], [67, Fraction(106262, 84551)],
 [68, Fraction(106262, 84551)], [69, Fraction(106262, 84551)], [70, Fraction(106262, 84551)], [94, Fraction(8430, 84551)], [182, Fraction(72, 84551)], [183, Fraction(1152, 422755)], [184, Fraction(72, 422755)],
 [185, Fraction(72, 422755)], [186, Fraction(6744, 422755)], [187, Fraction(4608, 422755)], [188, Fraction(408, 422755)], [189, Fraction(384, 422755)], [190, Fraction(192, 422755)], [191, Fraction(1800, 84551)],
 [202, Fraction(22170, 84551)], [226, Fraction(52240, 84551)], [231, Fraction(26720, 84551)], [233, Fraction(26720, 84551)], [234, Fraction(4800, 84551)], [238, Fraction(6720, 84551)], [277, Fraction(29610, 84551)],
 [310, Fraction(29610, 84551)], [311, Fraction(135872, 84551)], [319, Fraction(12150, 84551)], [327, Fraction(-12150, 84551)], [380, Fraction(-12150, 84551)], [570, Fraction(12150, 84551)],
 [592, Fraction(33750000, 97318201)], [607, Fraction(910, 84551)], [608, Fraction(910, 84551)], [609, Fraction(910, 84551)], [611, Fraction(33750000, 97318201)], [612, Fraction(33750000, 97318201)],
 [613, Fraction(33750000, 97318201)], [614, Fraction(33750000, 97318201)], [615, Fraction(33750000, 97318201)], [616, Fraction(33750000, 97318201)], [617, Fraction(33750000, 97318201)],
 [618, Fraction(33750000, 97318201)], [619, Fraction(33750000, 97318201)], [620, Fraction(33750000, 97318201)], [621, Fraction(33750000, 97318201)], [631, Fraction(12990, 84551)], [632, Fraction(12990, 84551)],
 [633, Fraction(12990, 84551)], [634, Fraction(12990, 84551)], [635, Fraction(25980, 84551)], [636, Fraction(25980, 84551)], [637, Fraction(12990, 84551)], [638, Fraction(12990, 84551)], [639, Fraction(4770, 84551)],
 [641, Fraction(22170, 84551)], [642, Fraction(22170, 84551)], [643, Fraction(22170, 84551)], [645, Fraction(22170, 84551)], [646, Fraction(22170, 84551)], [647, Fraction(22170, 84551)], [648, Fraction(22170, 84551)],
 [650, Fraction(-22170, 84551)], [654, Fraction(10680, 84551)], [655, Fraction(10680, 84551)], [661, Fraction(10680, 84551)], [664, Fraction(5040, 84551)], [671, Fraction(4890, 84551)], [672, Fraction(4890, 84551)],
 [673, Fraction(4890, 84551)], [674, Fraction(4890, 84551)], [677, Fraction(4890, 84551)], [678, Fraction(4890, 84551)], [679, Fraction(4890, 84551)], [680, Fraction(4890, 84551)], [687, Fraction(8430, 84551)],
 [689, Fraction(8430, 84551)], [691, Fraction(8430, 84551)], [692, Fraction(8430, 84551)], [695, Fraction(8430, 84551)], [736, Fraction(12150, 84551)], [744, Fraction(12150, 84551)], [745, Fraction(12150, 84551)],
 [746, Fraction(12150, 84551)], [747, Fraction(12150, 84551)], [748, Fraction(12150, 84551)], [749, Fraction(12150, 84551)], [752, Fraction(600000, 84551)], [753, Fraction(30000, 84551)], [754, Fraction(190000, 84551)],
 [755, Fraction(40000, 84551)], [756, Fraction(20000, 84551)], [757, Fraction(5000, 84551)], [758, Fraction(38000, 84551)], [759, Fraction(30000, 84551)], [760, Fraction(1000000, 84551)], [788, Fraction(-8430, 84551)],
 [891, Fraction(1000000, 84551)]]
# Check how many reactions are contained in it
>>> len(model.reactionSubsets[0].pairs)
107
# Check if it is reversible
>>> model.reactionSubsets[0].reversible
False
# Check how many reaction subsets there are altogether
>>> len(model.reactionSubsets)
360
# Compute the size of the reduced matrix
>>> m2,n2=getSize(model.reducedMatrix)
>>> m2
161
>>> n2
360
# Compute the reduction factors
>>> float(n1)/n2
2.477777777777778
>>> float(m1)/m2
6.192546583850931
# From here on, you can perform other analyses - minimal media, essential and synthetic lethal reactions, and energy balance analysis - using the reduced matrix!
# Don't forget to save your work
>>> s['AB1'] = model
# and close the shelve file
>>> s.close()
